package com.example.backcoverdetection;

import com.example.backcoverdetection.R;

import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Bundle;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.util.Log;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {

	Ringtone tone;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		Uri notification = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
	    tone = RingtoneManager.getRingtone(getApplicationContext(), notification);		
		//tone = RingtoneManager.getRingtone(this, RingtoneManager.getActualDefaultRingtoneUri(this, RingtoneManager.TYPE_NOTIFICATION));
		
		// Register for com.oem.hardware.intent.action.backcover
		IntentFilter ifilter = new IntentFilter("com.oem.hardware.intent.action.backcover");
		Intent backCoverStatus = this.registerReceiver(null, ifilter);
		if(backCoverStatus != null)
			determineCoverStatus(backCoverStatus);
		else
		{
			TextView statusText = (TextView) findViewById(R.id.textView1);
		
			statusText.setText("No cover detected");
			Log.d("------- Cover Detection ---------", "No cover detected");
		}
		
        this.registerReceiver(mBroadcastReceiver, ifilter);
	}

	final BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver() {

		@Override
		public void onReceive(Context context, Intent intent) {
			determineCoverStatus(intent);
		}
		
	};
	
	private void determineCoverStatus(Intent backCoverStatus) {
		int coverState = backCoverStatus.getIntExtra("state", -1);
		if(coverState == 1)
		{
			Log.d("------- Cover Detection ---------", "Cover detected!");
			TextView statusText = (TextView) findViewById(R.id.textView1);
			statusText.setText("Cover detected!");
			tone.play();
		}
		else
		{
			Log.d("------- Cover Detection ---------", "No cover detected");
			TextView statusText = (TextView) findViewById(R.id.textView1);
			statusText.setText("No cover detected");
			tone.play();
		}
	}	

	public void onDestroy()
	{
		this.unregisterReceiver(mBroadcastReceiver);
		super.onDestroy();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
