package com.example.barcodereaderintentreceiver;

import java.util.Arrays;

import com.oem.barcode.BCRConfig.BCRCodeType;
import com.oem.barcode.BCRIntents;

import android.os.Bundle;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {

	final BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver() {
	    @Override
	    public void onReceive(Context context, Intent intent) {
	        if (intent != null) {
	            final String action = intent.getAction();
	            if (BCRIntents.ACTION_NEW_DATA.equals(action)) {
	            	byte[] data = intent.getByteArrayExtra(BCRIntents.EXTRA_BCR_DATA);
	            	int type = intent.getIntExtra(BCRIntents.EXTRA_BCR_TYPE, -1);
	            	String decodedBarcode = intent.getStringExtra(BCRIntents.EXTRA_BCR_STRING);
	            	String charset = intent.getStringExtra(BCRIntents.EXTRA_BCR_CHARSET);
	            	
	            	if(data != null)
	            		((TextView)findViewById(R.id.textViewData)).setText(Arrays.toString(data));
	            	
	            	((TextView)findViewById(R.id.textViewType)).setText(TypeToString(type));
	            	
	            	((TextView)findViewById(R.id.textViewString)).setText(decodedBarcode);
	            	
	            	((TextView)findViewById(R.id.textViewEncoding)).setText(charset);
	            }
	        }
	    }
	    
	    String TypeToString(int type)
	    {
	    	switch(type)
	    	{
	    	case BCRCodeType.CODE_AZTEC:
	    		return "BCRCodeType.CODE_AZTEC";
	    	case BCRCodeType.CODE_AZTEC_RUNES:
	    		return "BCRCodeType.CODE_AZTEC_RUNES";
	    	case BCRCodeType.CODE_CHINESE_POST_MAT:
	    		return "BCRCodeType.CODE_CHINESE_POST_MAT";
	    	case BCRCodeType.CODE_CODABAR:
	    		return "BCRCodeType.CODE_CODABAR";
	    	case BCRCodeType.CODE_CODABLOCK_F:
	    		return "BCRCodeType.CODE_CODABLOCK_F";
	    	case BCRCodeType.CODE_CODE11:
	    		return "BCRCodeType.CODE_CODE11";
	    	case BCRCodeType.CODE_CODE128:
	    		return "BCRCodeType.CODE_CODE128";
	    	case BCRCodeType.CODE_CODE39:
	    		return "BCRCodeType.CODE_CODE39";
	    	case BCRCodeType.CODE_CODE93:
	    		return "BCRCodeType.CODE_CODE93";
	    	case BCRCodeType.CODE_DATAMATRIX_ECC000_140:
	    		return "BCRCodeType.CODE_DATAMATRIX_ECC000_140";
	    	case BCRCodeType.CODE_DATAMATRIX_ECC200:
	    		return "BCRCodeType.CODE_DATAMATRIX_ECC200";
	    	case BCRCodeType.CODE_EAN:
	    		return "BCRCodeType.CODE_EAN";
	    	case BCRCodeType.CODE_EAN13:
	    		return "BCRCodeType.CODE_EAN13";
	    	case BCRCodeType.CODE_EAN13_2:
	    		return "BCRCodeType.CODE_EAN13_2";
	    	case BCRCodeType.CODE_EAN13_5:
	    		return "BCRCodeType.CODE_EAN13_5";
	    	case BCRCodeType.CODE_EAN13_CC_A_B:
	    		return "BCRCodeType.CODE_EAN13_CC_A_B";
	    	case BCRCodeType.CODE_EAN8:
	    		return "BCRCodeType.CODE_EAN8";
	    	case BCRCodeType.CODE_EAN8_2:
	    		return "BCRCodeType.CODE_EAN8_2";
	    	case BCRCodeType.CODE_EAN8_5:
	    		return "BCRCodeType.CODE_EAN8_5";
	    	case BCRCodeType.CODE_EAN_2:
	    		return "BCRCodeType.CODE_EAN_2";
	    	case BCRCodeType.CODE_EAN_5:
	    		return "BCRCodeType.CODE_EAN_5";
	    	case BCRCodeType.CODE_GS1_128:
	    		return "BCRCodeType.CODE_GS1_128";
	    	case BCRCodeType.CODE_GS1_CC_A_B_C:
	    		return "BCRCodeType.CODE_GS1_CC_A_B_C";
	    	case BCRCodeType.CODE_GS1_DATABAR:
	    		return "BCRCodeType.CODE_GS1_DATABAR";
	    	case BCRCodeType.CODE_GS1_DATABAR_EXPANDED:
	    		return "BCRCodeType.CODE_GS1_DATABAR_EXPANDED";
	    	case BCRCodeType.CODE_GS1_DATABAR_LIMITED:
	    		return "BCRCodeType.CODE_GS1_DATABAR_LIMITED";
	    	case BCRCodeType.CODE_HAN_XIN:
	    		return "BCRCodeType.CODE_HAN_XIN";
	    	case BCRCodeType.CODE_IATA:
	    		return "BCRCodeType.CODE_IATA";
	    	case BCRCodeType.CODE_INDUSTRIAL_2OF5:
	    		return "BCRCodeType.CODE_INDUSTRIAL_2OF5";
	    	case BCRCodeType.CODE_INTELLIGENT_MAIL:
	    		return "BCRCodeType.CODE_INTELLIGENT_MAIL";
	    	case BCRCodeType.CODE_INTERLEAVED_2OF5:
	    		return "BCRCodeType.CODE_INTERLEAVED_2OF5";
	    	case BCRCodeType.CODE_JPN:
	    		return "BCRCodeType.CODE_JPN";
	    	case BCRCodeType.CODE_KOREAN_POSTAL_AU:
	    		return "BCRCodeType.CODE_KOREAN_POSTAL_AU";
	    	case BCRCodeType.CODE_MATRIX_2OF5:
	    		return "BCRCodeType.CODE_MATRIX_2OF5";
	    	case BCRCodeType.CODE_MAXI_CODE:
	    		return "BCRCodeType.CODE_MAXI_CODE";
	    	case BCRCodeType.CODE_MICRO_PDF417:
	    		return "BCRCodeType.CODE_MICRO_PDF417";
	    	case BCRCodeType.CODE_MICRO_QR_CODE:
	    		return "BCRCodeType.CODE_MICRO_QR_CODE";
	    	case BCRCodeType.CODE_MSI_PLESSEY:
	    		return "BCRCodeType.MSI_PLESSEY";
	    	case BCRCodeType.CODE_PDF417:
	    		return "BCRCodeType.CODE_PDF417";
	    	case BCRCodeType.CODE_POSTNET:
	    		return "BCRCodeType.CODE_POSTNET";
	    	case BCRCodeType.CODE_QR_CODE:
	    		return "BCRCodeType.CODE_QR_CODE";
	    	case BCRCodeType.CODE_SCODE:
	    		return "BCRCodeType.CODE_SCODE";
	    	case BCRCodeType.CODE_TELEPEN:
	    		return "BCRCodeType.CODE_TELEPEN";
	    	case BCRCodeType.CODE_Tri_Optic:
	    		return "BCRCodeType.CODE_Tri_Optic";
	    	case BCRCodeType.CODE_UK_PLESSEY:
	    		return "BCRCodeType.CODE_UK_PLESSEY";
	    	case BCRCodeType.CODE_UPC_A:
	    		return "BCRCodeType.CODE_UPC_A";
	    	case BCRCodeType.CODE_UPC_A_2:
	    		return "BCRCodeType.CODE_UPC_A_2";
	    	case BCRCodeType.CODE_UPC_A_5:
	    		return "BCRCodeType.CODE_UPC_A_5";
	    	case BCRCodeType.CODE_UPC_E:
	    		return "BCRCodeType.CODE_UPC_E";
	    	case BCRCodeType.CODE_UPC_E_2:
	    		return "BCRCodeType.CODE_UPC_E_2";
	    	case BCRCodeType.CODE_UPC_E_5:
	    		return "BCRCodeType.CODE_UPC_E_5";
	    	case BCRCodeType.CODE_UNKNOWN:
	    		return "BCRCodeType.CODE_UNKNOWN";
	    	}
	    	
    		return "BCRCodeType.CODE_UNKNOWN";
	    }
	};
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		IntentFilter filter = new IntentFilter();
		filter.addAction(BCRIntents.ACTION_NEW_DATA); 
		this.registerReceiver(mBroadcastReceiver, filter);
	}

	@Override
	public void onDestroy()
	{
		this.unregisterReceiver(mBroadcastReceiver);
		super.onDestroy();
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
