package com.example.dockdetection;





import android.os.Bundle;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		IntentFilter ifilter = new IntentFilter(Intent.ACTION_DOCK_EVENT);
		Intent dockStatus = this.registerReceiver(null, ifilter);
		if(dockStatus != null)
			determineDockStatus(dockStatus);
		else
		{
			TextView statusText = (TextView) findViewById(R.id.textView1);
		
			statusText.setText("No dock detected");
		}
		
        this.registerReceiver(mBroadcastReceiver, ifilter);
	}

	final BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver() {

		@Override
		public void onReceive(Context context, Intent intent) {
			determineDockStatus(intent);
		}
		
	};
	
	private void determineDockStatus(Intent dockStatus) {
		int dockState = dockStatus.getIntExtra(Intent.EXTRA_DOCK_STATE, -1);
		boolean isDocked = dockState != Intent.EXTRA_DOCK_STATE_UNDOCKED;
		boolean isCar = dockState == Intent.EXTRA_DOCK_STATE_CAR;
		boolean isDesk = dockState == Intent.EXTRA_DOCK_STATE_DESK || 
		                 dockState == Intent.EXTRA_DOCK_STATE_LE_DESK ||
		                 dockState == Intent.EXTRA_DOCK_STATE_HE_DESK;
		if(isDocked)
		{
			TextView statusText = (TextView) findViewById(R.id.textView1);
			if(isCar)
				statusText.setText("Dock detected! Type: CAR");
			else if(isDesk)
				statusText.setText("Dock detected! Type: DESK");
			else
				statusText.setText("Dock detected! Type: UNKNOWN");
		}
		else
		{
			TextView statusText = (TextView) findViewById(R.id.textView1);
			statusText.setText("No dock detected");
		}
	}

	public void onDestroy()
	{
		this.unregisterReceiver(mBroadcastReceiver);
		super.onDestroy();
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
