package com.example.keyremapviaintents;





import android.os.Bundle;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.view.KeyEvent;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {
	final BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver() {
	    @Override
	    public void onReceive(Context context, Intent intent) {
	    	VerifyIntent(intent);
	    }
	};
	
	void VerifyIntent(Intent intent)
	{
        if (intent != null) {
            final String action = intent.getAction();
            Bundle extras = intent.getExtras();
            KeyEvent keyEvent = (KeyEvent)extras.get(Intent.EXTRA_KEY_EVENT);
            int keyAction = keyEvent.getAction();
            
            if ("android.intent.action.SEARCH_LONG_PRESS".equals(action)) {
            	TextView textViewSearch = (TextView)findViewById(R.id.textViewAction);
            	textViewSearch.setText("SEARCH_LONG_PRESS");
            }
            else if("com.oem.hardware.intent.action.LEFT_SCAN".equals(action))
            {
            	TextView textViewSearch = (TextView)findViewById(R.id.textViewAction);
            	if(keyAction == KeyEvent.ACTION_DOWN)
            	{
            		textViewSearch.setText("LEFT_SCAN - DOWN");
            	}
            	else if(keyAction == KeyEvent.ACTION_UP)
            	{
            		textViewSearch.setText("LEFT_SCAN - UP");
            	}
            	else
            	{
            		textViewSearch.setText("LEFT_SCAN - ???");
            	}
            }
            else if("com.oem.hardware.intent.action.LEFT_SCAN_LONG_PRESS".equals(action))
            {
            	TextView textViewSearch = (TextView)findViewById(R.id.textViewAction);
            	textViewSearch.setText("LEFT_SCAN_LONG_PRESS");
            }
            else if("com.oem.hardware.intent.action.RIGHT_SCAN".equals(action))
            {
            	TextView textViewSearch = (TextView)findViewById(R.id.textViewAction);
            	if(keyAction == KeyEvent.ACTION_DOWN)
            	{
            		textViewSearch.setText("RIGHT_SCAN - DOWN");
            	}
            	else if(keyAction == KeyEvent.ACTION_UP)
            	{
            		textViewSearch.setText("RIGHT_SCAN - UP");
            	}
            	else
            	{
            		textViewSearch.setText("RIGHT_SCAN - ???");
            	}
            }
            else if("com.oem.hardware.intent.action.RIGHT_SCAN_LONG_PRESS".equals(action))
            {
            	TextView textViewSearch = (TextView)findViewById(R.id.textViewAction);
            	textViewSearch.setText("RIGHT_SCAN_LONG_PRESS");
            }
        }
}
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		IntentFilter filter = new IntentFilter();
        filter.addAction("android.intent.action.SEARCH_LONG_PRESS");
        filter.addAction("com.oem.hardware.intent.action.LEFT_SCAN");
        filter.addAction("com.oem.hardware.intent.action.LEFT_SCAN_LONG_PRESS");
        filter.addAction("com.oem.hardware.intent.action.RIGHT_SCAN");
        filter.addAction("com.oem.hardware.intent.action.RIGHT_SCAN_LONG_PRESS");
        Intent intent = this.registerReceiver(mBroadcastReceiver, filter);
        VerifyIntent(intent);
	}

	public void onDestroy()
	{
		this.unregisterReceiver(mBroadcastReceiver);
		super.onDestroy();
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	
		
	

}
